%
% script para un codigo de diferencias finitas en coordenadas cartesianas en 2D
%

global data

% la variable initia dice si el calculo por iniciar arranca de cero o es
% continuacion de otro preexistente en memoria.
% initia = 1 : arranca de cero , no hay registro anterior en memoria
% initia = 0 : continuacion de una corrida anterior

if(exist('initia')==0),
    disp('Enter variable INITIA ')
    disp(' initia == 0 ---> if is a continuation of an older run  ')
    disp(' initia ~= 0 ---> if started from the beginning  ')
    initia = input(' Initia = ')

    read_data;

    bfh_state = [];
    
end

nsave = 1;

R = zeros(numnp,1);

% do the computation
for itime=1:ntime
            
    ttime = ttime+dt;    
    data.state_old = data.state;
    
    % calling a function to change some data time to time
    time_step_pre;
    
    % iteraciones del Newton en caso que el problema sea no lineal    
    check_conv = 1;
    iter = 1;
    while check_conv
        % ensamblaje de la matriz y del residuo
        [K,R] = fdm_assemble();
        % resolucion del sistema, basado en incrementos
        [phi_new,R] = fdm_solver(data,K,R);
        % update solution
        data.state = phi_new;
        % convergence check
        disp([' time step = ' num2str(itime) ' t= ' num2str(ttime) ' | R | = ' num2str(norm(R))])
        check_conv = (norm(R)>tol_newton)&(iter<=maxit);
        iter = iter+1;
    end
    % plot
    fdm_plot(data,itime)
    % save each nsave time steps the state
    if rem(itime,nsave)==0
        bfh_state = [bfh_state,data.state];
    end
end

